<?php
/*
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

date_default_timezone_set("Europe/Paris");
// i18n
/*$lang = 'fr_FR';
$text_domain = "messages";
setlocale(LC_ALL, $lang);
bindtextdomain($text_domain, "./locale");
textdomain($text_domain);*/

include("./jpgraph/src/jpgraph.php");
include("./jpgraph/src/jpgraph_line.php");
require_once("./jpgraph/src/jpgraph_date.php");

$cache_directory = "/var/www/cache";
$pre_generated_image_path = "./nagios-cache";

$db_host = "localhost";
$db_user = "root";
$db_pass = "";
$db_name = "nagios";

$nagios_connection = mysql_connect($db_host, $db_user, $db_pass, "true");
mysql_select_db($db_name, $nagios_connection);

$elements_to_get = array("name1", "name2", "output_raw_value", "start_date", "end_date", "indicator", "size", "hide_legend", "refresh", "agregate", "graph_type", "max_value", "min_value", "date_format");

// Here set values that you want to customize or skip
$customize_value = array(
"LOAD" => array(1 => "skip", 2 => "skip"),
"CPU" => array("warn" => "skip", "crit" => "skip"),
"DISQUE" => array(0 => "-free", 1 => "skip", 2 => "skip", 3 => "-total"));

$default_graph_mode = array("CPU" => "cumulate_area");

if(strlen($_GET["color"]) == 0) {
  $colors = array("#5555ff", "#ff5555", "#55ff55", "#ff55ff", "#A0F000", "#ffff55", "#956575", "#55ffff", "#ff00ff", "#7f7f00", "#A07fA0", "#7f7f7f", "#7f007f");
  $color = implode(",", $colors);
} else {
  $color = $_GET["color"];
  $colors = explode(",", $color);
}
foreach($elements_to_get as $elt) {
  if(strlen($_GET[$elt]) > 0) {
    $$elt = $_GET["$elt"];
  }
}

if(strlen($max_value) == 0) {
  $max_value = false;
}

if(strlen($min_value) == 0) {
  $min_value = 0;
}

if(!is_array($name1)) {
  $name1 = array($name1);
}
if(!is_array($name2)) {
  $name2 = array($name2);
}

if(array_key_exists($name2[0], $default_graph_mode) && strlen($graph_type) ==0) {
  $graph_type = $default_graph_mode[$name2[0]];
}

if(strlen($date_format) == 0) {
  if(!$dump_graphic) {
    $date_format = 'd/m H:i';
  } else {
    $date_format = 'H:i';
  }
}

// Checking various values
$default_time_period = "-24 hour";
if($dump_graphic)
  $default_time_period = "-1 hours";
if(strlen($start_date) == 0)
  $start_date = date("Y-m-d H:i", strtotime($default_time_period));

if(strlen($end_date) == 0)
  $end_date = "now";

if(strlen($agregate) == 0)
  $agregate = 1;

if(count($indicator) == 0) $indicator = false;

if(strlen($size) > 0) {
  list($size_x, $size_y) = explode("x", $size);
} else {
  if(!$dump_graphic)
    $size = "1000x400";
  else
    $size = "500x300";
}

if($size_x == 0 || $size_y == 0) {
  if(strlen($size) == 0) {
    $size_x = 600; $size_y = 400;
  } else {
    list($size_x, $size_y) = explode("x", $size);
  }
}

// Computing various date used to get values from MySQL
$start_timestamp = strtotime($start_date);
$end_timestamp = strtotime($end_date);
$start = date("Y-m-d H:i:s", $start_timestamp);
$end = date("Y-m-d H:i:s", $end_timestamp);
$date_picture = date("Y-m-d-H-i", $start_timestamp);
$date_picture .= date("-Y-m-d-H-i", $end_timestamp);
$picture_name = implode("-", $name1)."--".implode("-", $name2)."-$date_picture";
?>
